Loading...
Searching...
No Matches
Sip_content_type

## Data Structures

struct | sip_content_type_s
| Structure for Content-Type header. More...

## Macros

#define | sip_content_type(sip)
| Access a SIP Content-Type header structure sip_content_type_t from sip_t.
#define | SIP_CONTENT_TYPE_INIT()
| Initializer for structure sip_content_type_t.
#define | SIPTAG_CONTENT_TYPE(x)
| Tag list item for pointer to a Content-Type header structure sip_content_type_t.
#define | SIPTAG_CONTENT_TYPE_REF(x)
| Tag list item for reference to a Content-Type header pointer.
#define | SIPTAG_CONTENT_TYPE_STR(s)
| Tag list item for string with Content-Type header value.
#define | SIPTAG_CONTENT_TYPE_STR_REF(x)
| Tag list item for reference to a Content-Type header string.

## Typedefs

typedef struct msg_content_type_s | sip_content_type_t
| @

## Functions

issize_t | sip_content_type_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Content-Type header.
issize_t | sip_content_type_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Content-Type header.
sip_content_type_t * | sip_content_type_init (sip_content_type_t x[1])
| Initialize a structure sip_content_type_t.
int | sip_is_content_type (sip_header_t const *header)
| Test if header object is instance of sip_content_type_t.
sip_content_type_t * | sip_content_type_dup (su_home_t *home, sip_content_type_t const *hdr))
| Duplicate a list of Content-Type header header structures sip_content_type_t.
sip_content_type_t * | sip_content_type_copy (su_home_t *home, sip_content_type_t const *hdr))
| Copy a list of Content-Type header header structures sip_content_type_t.
sip_content_type_t * | sip_content_type_make (su_home_t *home, char const *s))
| Make a Content-Type header structure sip_content_type_t.
sip_content_type_t * | sip_content_type_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Type header from formatting result.

## Variables

msg_hclass_t | sip_content_type_class []
| Header class for Content-Type header.
tag_typedef_t | siptag_content_type
| Tag for Content-Type header object.
tag_typedef_t | siptag_content_type_str
| Tag for string with Content-Type header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CONTENT_TYPE_INIT

#define SIP_CONTENT_TYPE_INIT | ( |  | ) |

Initializer for structure sip_content_type_t.

A static sip_content_type_t structure for Content-Type header must be initialized with the SIP_CONTENT_TYPE_INIT() macro. For instance,

sip_content_type_t sip_content_type = SIP_CONTENT_TYPE_INIT;
sip_content_type_t
struct msg_content_type_s sip_content_type_t
@
Definition sip.h:155
sip_content_type
#define sip_content_type(sip)
Access a SIP Content-Type header structure sip_content_type_t from sip_t.
Definition sip_protos.h:14887
SIP_CONTENT_TYPE_INIT
#define SIP_CONTENT_TYPE_INIT()
Initializer for structure sip_content_type_t.
Definition sip_protos.h:14904

## SIPTAG_CONTENT_TYPE

#define SIPTAG_CONTENT_TYPE | ( |  | x | ) |

Tag list item for pointer to a Content-Type header structure sip_content_type_t.

The SIPTAG_CONTENT_TYPE() macro is used to include a tag item with a pointer to a sip_content_type_t structure in a tag list.

Parameters

  x | pointer to a sip_content_type_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CONTENT_TYPE_REF().

## SIPTAG_CONTENT_TYPE_STR

#define SIPTAG_CONTENT_TYPE_STR | ( |  | s | ) |

Tag list item for string with Content-Type header value.

The SIPTAG_CONTENT_TYPE_STR() macro is used to include a tag item with a string containing value of a sip_content_type_t header in a tag list.

Parameters

  s | pointer to a string containing Content-Type header value, or NULL.

The string in SIPTAG_CONTENT_TYPE_STR() can be converted to a sip_content_type_t header structure by giving the string s has second argument to function sip_content_type_make().

The corresponding tag taking reference parameter is SIPTAG_CONTENT_TYPE_STR_REF().

## Typedef Documentation

## sip_content_type_t

typedef struct msg_content_type_s sip_content_type_t

@

The Content-Type header indicates the media type of the message-body sent to the recipient. Its syntax is defined in [H3.7, S] as follows:

Content-Type = ( "Content-Type" / "c" ) HCOLON media-type
media-type = m-type SLASH m-subtype *(SEMI m-parameter)
m-type = discrete-type / composite-type
discrete-type = "text" / "image" / "audio" / "video"
/ "application" / extension-token
composite-type = "message" / "multipart" / extension-token
extension-token = ietf-token / x-token
ietf-token = token
x-token = "x-" token
m-subtype = extension-token / iana-token
iana-token = token
m-parameter = m-attribute EQUAL m-value
m-attribute = token
m-value = token / quoted-string
Type
struct node Type

The parsed Content-Type header is stored in sip_content_type_t structure.

The structure sip_content_type_t contains representation of SIP Content-Type header.

The sip_content_type_t is defined as follows:

typedef struct sip_content_type_s {
sip_common_t c_common[1]; // Common fragment info
sip_unknown_t *c_next; // Dummy link to next
char const *c_type; // Pointer to type/subtype
char const *c_subtype; // Points after first slash in type
msg_param_t const *c_params; // List of parameters
} sip_content_type_t;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_content_type_s
Structure for Content-Type header.
Definition sip.h:501
sip_content_type_s::c_params
msg_param_t const * c_params
List of parameters.
Definition sip.h:506
sip_content_type_s::c_next
sip_error_t * c_next
Dummy link to next.
Definition sip.h:503
sip_content_type_s::c_common
sip_common_t c_common[1]
Common fragment info.
Definition sip.h:502
sip_content_type_s::c_type
char const * c_type
Pointer to type/subtype.
Definition sip.h:504
sip_content_type_s::c_subtype
char const * c_subtype
Points after first slash in type.
Definition sip.h:505

The whitespace in the c_type is always removed when parsing.

## Function Documentation

## sip_content_type_copy()

sip_content_type_t * sip_content_type_copy | ( | su_home_t * | home,
|  | sip_content_type_t const * | hdr )

inline

Copy a list of Content-Type header header structures sip_content_type_t.

The function sip_content_type_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  content_type = sip_content_type_copy(home, sip->sip_content_type);
  sip_content_type_copy
  sip_content_type_t * sip_content_type_copy(su_home_t *home, sip_content_type_t const *hdr))
  Copy a list of Content-Type header header structures sip_content_type_t.
  Definition sip_protos.h:15034

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_content_type_dup()

sip_content_type_t * sip_content_type_dup | ( | su_home_t * | home,
|  | sip_content_type_t const * | hdr )

inline

Duplicate a list of Content-Type header header structures sip_content_type_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_type = sip_content_type_dup(home, sip->sip_content_type);
  sip_content_type_dup
  sip_content_type_t * sip_content_type_dup(su_home_t *home, sip_content_type_t const *hdr))
  Duplicate a list of Content-Type header header structures sip_content_type_t.
  Definition sip_protos.h:14991

Returns
  A pointer to the newly duplicated sip_content_type_t header structure, or NULL upon an error.

## sip_content_type_format()

sip_content_type_t * sip_content_type_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Type header from formatting result.

Make a new sip_content_type_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_content_type_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_content_type_init()

sip_content_type_t * sip_content_type_init | ( | sip_content_type_t | x[1] | ) |

inline

Initialize a structure sip_content_type_t.

An sip_content_type_t structure for Content-Type header can be initialized with the sip_content_type_init() function/macro. For instance,

sip_content_type_t sip_content_type;
sip_content_type_init(&sip_content_type);
sip_content_type_init
sip_content_type_t * sip_content_type_init(sip_content_type_t x[1])
Initialize a structure sip_content_type_t.
Definition sip_protos.h:14922

## sip_content_type_make()

sip_content_type_t * sip_content_type_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Content-Type header structure sip_content_type_t.

The function sip_content_type_make() makes a new sip_content_type_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_content_type_t header structure, or NULL upon an error.

## sip_is_content_type()

int sip_is_content_type | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_content_type_t.

Check if the header class is an instance of Content-Type header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header content_type
  0 | (false) otherwise

## Variable Documentation

## sip_content_type_class

msg_hclass_t sip_content_type_class[]

extern

Header class for Content-Type header.

The header class sip_content_type_class defines how a SIP Content-Type header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_content_type_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.